variables:
  TEST_PROJECT_NAME: Otus.Teaching.PromoCodeFactory.UnitTests

stages:
  - build
  - test
  - deploy

Build:
  stage: build
  image: docker:19.03.12
  services:
    - docker:19.03.12-dind
  script:
    - echo $CI_TOKEN | docker login registry.gitlab.com -u deploy-token --password-stdin
    - docker build ./ -t $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest

test:
  image: mcr.microsoft.com/dotnet/core/sdk:3.1
  stage: test
  script: 
      - dotnet test $TEST_PROJECT_NAME/$TEST_PROJECT_NAME.csproj

deploy:
    stage: deploy
    script:
      - echo "kubectl apply -f promocode-factory-api.yaml"
